var all_different_pitches;
var all_different_pitches_length;
var current_pitch_low_limit_index;
var current_pitch_high_limit_index;
var pitch_low_limit_image;
var pitch_high_limit_image;
var contimbre_choice2;
var contimbre_choice2_length;

var current_lowest_partial_index;
var current_partial1_index;
var current_partial2_index;

var pitch_changing;
var pitch_change_action;

function find_value (lval,larray)
{
    var lflag = false;
    var larray_length = larray.length;
    var i=0; 
    while ((!lflag)&&(i<larray_length)) {
      if (lval==larray[i]) lflag=true;
      i++;
    }
    return lflag;
}

/************************pitch***********************************************************/
  function stop_pitch_change()
  {
    window.clearTimeout(pitch_changing);
  }

  function pitch_low_limit_up ()
  {
    if(current_pitch_low_limit_index < (all_different_pitches.length-2))
    {
      current_pitch_low_limit_index++;
      pitch_low_limit_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_pitches[current_pitch_low_limit_index] + ".gif";
    }
  }

  function periodic_pitch_change ()
  {
     pitch_changing = window.setInterval(pitch_change_action,50);
  }

  function do_nothing ()
  {
   }

  function start_pitch_change (laction)
  {
    pitch_change_action = laction;
    pitch_change_action();
    pitch_changing = window.setTimeout(periodic_pitch_change,500);
  }

  function pitch_low_limit_down ()
  {
    if(current_pitch_low_limit_index > 1)
    {
      current_pitch_low_limit_index--;
      pitch_low_limit_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_pitches[current_pitch_low_limit_index] + ".gif";
    }
  }

  function pitch_high_limit_up ()
  {
    if(current_pitch_high_limit_index < (all_different_pitches.length-2))
    {
      current_pitch_high_limit_index++;
      pitch_high_limit_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_pitches[current_pitch_high_limit_index] + ".gif";
    }
  }

  function pitch_high_limit_down ()
  {
    if(current_pitch_high_limit_index > 1)
    {
      current_pitch_high_limit_index--;
      pitch_high_limit_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_pitches[current_pitch_high_limit_index] + ".gif";
    }
  }

/************************partials********************************************************/

  function lowest_partial_down ()
  {
    if(current_lowest_partial_index > 1)
    {
      current_lowest_partial_index--;
      lowest_partial_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_lowest_partial_pitches[current_lowest_partial_index] + ".gif";
    }
  }


  function lowest_partial_up ()
  {
    if(current_lowest_partial_index < (all_different_lowest_partial_pitches.length - 2))
    {
      current_lowest_partial_index++;
      lowest_partial_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_lowest_partial_pitches[current_lowest_partial_index] + ".gif";
    }
  }


  function partial1_down ()
  {
    if(current_partial1_index > 1)
    {
      current_partial1_index--;
      partial1_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_strongest_partial_pitches[current_partial1_index] + ".gif";
    }
  }


  function partial1_up ()
  {
    if(current_partial1_index < (all_different_strongest_partial_pitches.length - 2))
    {
      current_partial1_index++;
      partial1_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_strongest_partial_pitches[current_partial1_index] + ".gif";
    }
  }


  function partial2_down ()
  {
    if(current_partial2_index > 1)
    {
      current_partial2_index--;
      partial2_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_2strongest_partial_pitches[current_partial2_index] + ".gif";
    }
  }


  function partial2_up ()
  {
    if(current_partial2_index < (all_different_2strongest_partial_pitches.length - 2))
    {
      current_partial2_index++;
      partial2_image.src="../../../../../graphics/quarter_tones/quarter_tone" 
                   + all_different_2strongest_partial_pitches[current_partial2_index] + ".gif";
    }
  }


/************************search***********************************************************/
function get_comments (llist,index) {
  return llist[index][0];
}

function get_partial (llist,index) {
  return llist[index][1];
}

function get_lowest_partial (llist,index) {
  return llist[index][2];
}

function get_pitch (llist,index) {
  return llist[index][3];
}

function get_spectral_center (llist,index) {
  return llist[index][4];
}

function get_spectral_complexity (llist,index) {
  return llist[index][5];
}

function get_attack_time (llist,index) {
  return llist[index][6];
}

function get_absolute_intensity (llist,index) {
  return llist[index][7];
}

function get_type (llist,index) {
  return llist[index][8];
}

function get_language_modes (llist,index) {
  return llist[index][9];
}

function find_substring (lsubstring,lstring) {
  var ltest = eval("/" + lsubstring + "/i");
  var lposition = lstring.search(ltest);
  return (lposition > -1);
}

/****************searchresult functions***********/

function getResultType (index) {
  return all_different_types[resultlist[index][8]];
}

function getResultLanguageModes (index) {
  return resultlist[index][9];
}

function getResultFilename (index) {
  return resultlist[index][11];
}

function getResultFilepathRest (index) {
  return resultlist[index][12];
}

//***************sort routines****************//
function pitch_sort (a,b) {
  return a[3]-b[3];
}

function filename_sort (a,b) {
  var ldif;

if (a[10] > b[10]) 
  {
    ldif = 1;
  }
   else
  {
    ldif = -1;
  }
  return ldif;
}

function intensity_sort (a,b) {
  return a[7]-b[7];
}

function spectral_center_sort (a,b) {
  return a[4]-b[4];
}

function spectral_complexity_sort (a,b) {
  return a[5]-b[5];
}

function attack_time_sort (a,b) {
  return a[6]-b[6];
}

/********************************search******************************************/
/********************************search******************************************/
function search (){
  var contimbre_choice1 = contimbre;
  var contimbre_choice1_length = contimbre_choice1.length;
  var i,j, checked;
  var  low_pitch_limit = all_different_pitches[current_pitch_low_limit_index ];
  var high_pitch_limit = all_different_pitches[current_pitch_high_limit_index];

  contimbre_choice1 = contimbre;

  /********************search spectral_center***********************************/
  checked = document.getElementsByName("spectral_center")[0].checked;
  if (checked) {
    var low_limit  = document.getElementById("spectral_center_low_limit" ).value;
    var high_limit = document.getElementById("spectral_center_high_limit").value;
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lval= get_spectral_center(contimbre_choice1,i);
      if ((lval>= low_limit)&&(lval<= high_limit)) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search spectral_complexity***********************************/
  checked = document.getElementsByName("spectral_complexity")[0].checked;
  if (checked) {
    var low_limit  = document.getElementById("spectral_complexity_low_limit" ).value;
    var high_limit = document.getElementById("spectral_complexity_high_limit").value;
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lval= get_spectral_complexity(contimbre_choice1,i);
      if ((lval>= low_limit)&&(lval<= high_limit)) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search absolute_intensity***********************************/
  checked = document.getElementsByName("absolute_intensity")[0].checked;
  if (checked) {
    var low_limit  = document.getElementById("absolute_intensity_low_limit" ).value;
    var high_limit = document.getElementById("absolute_intensity_high_limit").value;
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lval= get_absolute_intensity(contimbre_choice1,i);
      if ((lval>= low_limit)&&(lval<= high_limit)) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search attack_time***********************************/
  checked = document.getElementsByName("attack_time")[0].checked;
  if (checked) {
    var low_limit  = document.getElementById("attack_time_low_limit" ).value;
    var high_limit = document.getElementById("attack_time_high_limit").value;
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lval= get_attack_time(contimbre_choice1,i);
      if ((lval>= low_limit)&&(lval<= high_limit)) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search pitch***********************************/
  checked = document.getElementsByName("pitch")[0].checked;
  if (checked) {
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lpitch=get_pitch(contimbre_choice1,i);
      if ((lpitch>=low_pitch_limit)&&(lpitch<=high_pitch_limit)) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search nopitch***********************************/
  checked = document.getElementsByName("no_pitch")[0].checked;
  if (checked) {
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lpitch=get_pitch(contimbre_choice1,i);
      if (lpitch<0) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /******************************** partials ***********************************/
  checked = document.getElementsByName("partials")[0].checked;
  if (checked) {
  /********************search lowest_partial***********************************/
  checked = document.getElementsByName("lowest_partial")[0].checked;
  if (checked) {
    var testpitch = all_different_lowest_partial_pitches[current_lowest_partial_index];
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lpitch=get_lowest_partial(contimbre_choice1,i);
      if (lpitch == testpitch) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search partial1***********************************/
  checked = document.getElementsByName("partial1")[0].checked;
  if (checked) {
    var testpitch = all_different_strongest_partial_pitches[current_partial1_index];
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lpitch=get_partial(contimbre_choice1,i)[0];
      if (lpitch == testpitch) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search partial2***********************************/
  checked = document.getElementsByName("partial2")[0].checked;
  if (checked) {
    var testpitch = all_different_2strongest_partial_pitches[current_partial2_index];
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lpitch=get_partial(contimbre_choice1,i)[1];
      if (lpitch == testpitch) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }
  /**************************************************************************/
  }

  /********************search nopartials*************************************/
  checked = document.getElementsByName("no_partials")[0].checked;
  if (checked) {
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      lpitch=get_lowest_partial(contimbre_choice1,i);
      if (lpitch<0) {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search modes or type*******************************/
  checked = document.getElementsByName("filename")[0].checked;
  if (checked) {
    var modes_substring = document.getElementById("file_substring").value;
    contimbre_choice2_length = 0;
    for (i=0;i<contimbre_choice1_length;i++) {
      var modes = get_language_modes(contimbre_choice1,i)[language_index];
      var typeindex  = get_type(contimbre_choice1,i);
      var type = all_different_types[typeindex];
      var lflag = false;
      for (j=0;j<(modes.length-1);j++)
      {
        var modes_index = modes[j];
        if (find_substring(modes_substring,all_different_modes_strings[modes_index])) {
          lflag = true;
          break;
        }
      }
       //type
      var ltest = eval("/" + modes_substring + "/i");
      if (type.search(ltest)>-1) lflag = true;

      if (lflag) 
      {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /********************search comments*******************************/
  checked = document.getElementsByName("comments")[0].checked;
  if (checked) {
    var comments_substring = document.getElementById("comments_substring").value;
    contimbre_choice2_length = 0;

    for (i=0;i<contimbre_choice1_length;i++) {
      var comments = get_comments(contimbre_choice1,i)[language_index];
      var lflag = false;
      for (j=0;j<(comments.length-1);j++)
      {
        var comments_index = comments[j];
        if (find_substring(comments_substring,all_different_comment_strings[comments_index])) {
          lflag = true;
          break;
        }
      }
      if (lflag) 
      {
        contimbre_choice2[contimbre_choice2_length] = contimbre_choice1[i];
        contimbre_choice2_length++;
      }
    }
    contimbre_choice1 = contimbre_choice2;
    contimbre_choice1_length = contimbre_choice2_length;
  }

  /****************************************/
  /********display result******************/
  /****************************************/
}

function displayResult (){
  resultlist_length = contimbre_choice2_length;
  resultlist        = contimbre_choice2.slice(0,resultlist_length);
  var sort_rule=document.getElementById("sort_rule").value;
  for (i=0;i < resultlist_length; i++)
  {
    var lfilename            = instrument[language_index] + "." +  getResultType(i);
    var language_indexlist   = getResultLanguageModes(i)[language_index];
    var rest                 = getResultFilepathRest(i);
    var indexlength          = language_indexlist.length-1;
        for (j=0;j<indexlength;j++)
        {
          var ll    = language_indexlist[j];
          var thismode          = all_different_modes_strings[ll];
          lfilename             = lfilename + "." + thismode;
        }

    lfilename = lfilename + "." + rest;
    resultlist[i][10]=lfilename;
  }
    switch(sort_rule) {
    case "pitch": 
      resultlist=resultlist.sort(pitch_sort);
      break;   
    case "intensity":
      resultlist = resultlist.sort(intensity_sort);
      break;   
    case "filename":
      resultlist=resultlist.sort(filename_sort);
      break;   
    case "spectral_center":
      resultlist=resultlist.sort(spectral_center_sort);
      break;   
    case "spectral_complexity":
      resultlist=resultlist.sort(spectral_complexity_sort);
      break;   
    case "attack_time":
      resultlist=resultlist.sort(attack_time_sort);
      break;   
    }
  searchresultpage = open("","searchPage "+instrument[english_language_index]);
  searchresultpage.document.body.innerHTML = "";
  searchresultpage.document.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\">");
  searchresultpage.document.write("<script src=\"../../../../../html/js/buildSearchResultPage.js\" type=\"text/javascript\"></script>");
  searchresultpage.document.write("<head><title>"+Suchergebnis[language_index]+" "+instrument[language_index]+"</title>");
  searchresultpage.document.write("</head><body bgcolor=\"#DDEEFF\"><table>");
  searchresultpage.document.write("<tr><td><h2>" + resultlist_length + " " + Treffer[language_index] +"</h2></td></tr>");
  for (i=0;i < resultlist_length; i++)
  {
    var lfilename            = resultlist[i][10];
    var iplus1               = i+1;
    var lhtmlpath = "../../../../../groups/" + group_english + "/"
                                + family_english + "/"
                                + instrument[english_language_index] + "/html/usage permitted only with a contimbre.com license "+instrument[english_language_index]+"." +  resultlist[i][11] + ".htm?selection=0"+language_index;

    searchresultpage.document.write("<tr><td>" + iplus1 + ": <a href=\"javascript:contimbre_searchresultlink('"+lhtmlpath+"')\">"  + lfilename);
         searchresultpage.document.write("</a></td></tr>");
  }
  searchresultpage.document.write("</table></body></html>");
}

function startsearch (){
  search();
    displayResult();
}


function show_hide (lflag,lid) {
  var tr = document.getElementById(lid);
  if (lflag)
    tr.style.display="block";
  else
    tr.style.display="none";
}

function show_hide_pitch (lflag) {
  var trno = document.getElementById("no_pitch");
  var tr = document.getElementById("pitch");
  var pitch_checked = document.getElementsByName("no_pitch")[0];
  if (lflag) {
    pitch_checked.checked=false;
    tr.style.display="block";
    }
  else
    tr.style.display="none";
}

function show_hide_nopitch (lflag) {
  var tr = document.getElementById("pitch");
  var pitch_checked = document.getElementsByName("pitch")[0];
  if (lflag) {
    tr.style.display="none";
    pitch_checked.checked=false;
    }
}

function show_hide_partials (lflag) {
  var trno = document.getElementById("no_partials");
  var tr = document.getElementById("partials");
  var partials_checked = document.getElementsByName("no_partials")[0];
  if (lflag) {
    partials_checked.checked=false;
    tr.style.display="block";
    }
  else
    tr.style.display="none";
}

function show_hide_nopartials (lflag) {
  var tr = document.getElementById("partials");
  var partials_checked = document.getElementsByName("partials")[0];
  if (lflag) {
    tr.style.display="none";
    partials_checked.checked=false;
    }
}

function hide (ltype) {
  var tr = document.getElementById(ltype);
  tr.style.display="none";
}

function change_sort (lval) {
    /********display result******************/
    displayResult();
}

function contimbre_language (lnum) {
  if (searchresultpage!=undefined) searchresultpage.close();
  location.href = "../../../../../groups/" + group_english  + "/" 
                                           + family_english + "/" 
                                           + instrument[english_language_index]
                                           + "/html/contimbre_search.htm?selection="+lnum;
}


function buildSearchPage1 () {
  all_different_pitches = new Array();
  all_different_pitches_length = 0;
  current_pitch_low_limit_index=1;
  current_pitch_high_limit_index = all_different_pitches.length-2;
  contimbre_choice2 = new Array(contimbre.length);
  contimbre_choice2_length = 0;
  current_lowest_partial_index = 1;
  current_partial1_index = 1;
  current_partial2_index = 1;
  for (i=0;i<known_languages.length;i++) {
       if (language_index==i)
         document.write("<td><a href=\"javascript:contimbre_language("+i+")\"><img src=\"../../../../../html/icons_and_backgrounds/"+known_languages[i]+".gif \" border=\"0 \"></a></td>");
       else
         document.write("<td><a href=\"javascript:contimbre_language("+i+")\"><img src=\"../../../../../html/icons_and_backgrounds/"+known_languages[i]+"_small.gif \" border=\"0 \"></a></td>");
  }

      
    document.write("<td><a href=\"../../../../../html/standard_pages/help_search_"+known_languages[language_index]+".htm\" target=\"_blank\"><img src=\"../../../../../html/icons_and_backgrounds/help.png \"border=\"0\"></a></td>");
    document.write("</tr></td></tr></table><tr><td align=\"center\"><h1 style=\"color:#115500 \">");

    document.write(Suche[language_index]);
    document.write("<br>" + instrument[language_index] + "</h1></td></tr>");
}
